var pipeline = [
  {
    "$project": {
      "user_created_at": "$user.created_at",
      "user_age": "$user.age"
    }
  },
  {
    "$project": {
      "user_created_at": 1,
      "user_age": 1,
      "h": {
        "$hour": "$user_created_at"
      },
      "m": {
        "$minute": "$user_created_at"
      },
      "s": {
        "$second": "$user_created_at"
      },
      "ms": {
        "$millisecond": "$user_created_at"
      },
      "d": {
        "$dayOfMonth": "$user_created_at"
      }
    }
  },
  {
    "$project": {
      "user_created_at": {
        "$subtract": [
          "$user_created_at",
          {
            "$add": [
              "$ms",
              {
                "$multiply": [
                  "$s",
                  1000
                ]
              },
              {
                "$multiply": [
                  "$m",
                  60,
                  1000
                ]
              },
              {
                "$multiply": [
                  "$h",
                  60,
                  60,
                  1000
                ]
              },
              {
                "$multiply": [
                  {
                    "$subtract": [
                      "$d",
                      1
                    ]
                  },
                  24,
                  60,
                  60,
                  1000
                ]
              }
            ]
          }
        ]
      },
      "user_age": 1
    }
  },
  {
    "$group": {
      "_id": "$user_created_at",
      "avg_age": {
        "$avg": "$user_age"
      }
    }
  },
  {
    "$project": {
      "avg_age": "$avg_age",
      "created": "$_id",
      "_id": 0
    }
  },
  {
    "$sort": {
      "created": 1
    }
  },
  {
    "$limit": 10
  }
] 