var pipeline = [
    {
        "$match" : {
            "project" : "SERVER",
            "fields.status" : "Open"
        }
    },
    {
        "$project" : {
            "fields_issuetype_name" : "$fields.issuetype.name",
            "fields_assignee_name" : "$fields.assignee.name"
        }
    },
    {
        "$group" : {
            "_id" : {
                "fields_issuetype_name" : "$fields_issuetype_name",
                "fields_assignee_name" : "$fields_assignee_name"
            },
            "value" : {
                "$sum" : 1
            }
        }
    },
    {
        "$project" : {
            "value" : "$value",
            "stacks" : "$_id",
            "_id" : 0
        }
    },

    {
        "$group" : {
            "_id" : "$stacks.fields_assignee_name",
            "total" : {
                "$sum" : "$value"
            },
            "values" : {
                "$push" : "$$ROOT"
            }
        }
    },
    {
        "$project" : {
            "total" : "$total",
            "label" : "$_id",
            "_id" : 0,
            "values" : "$values"
        }
    },
    {
        "$sort" : {
            "total" : -1
        }
    },
    {
        "$limit" : 2
    }
]